### Steps to train SN-GAN
The folder contains code to train SN-GAN  (Spectral Normalization GANs). 

### Dependencies

Create a conda environment from `environment.yml` and use it.

### Command to run 

>python main.py -t -e -c configs/CIFAR10/SNGAN-adabelief.json

Replace "optimizer" with the optimizer you wish to train with. Configurations related to 
different optimizers can be looked up from ```configs``` folder. Data-points generated from
training and logs are present in ```logs``` folder. To make these plots make use of [fid_SNGAN.py](fid_SNGAN.py), 
make sure you have tensorflow installed. You could alternatively make use of tensorboard to 
visualize these plots using ```tf.events``` files that are generated in ```logs``` folder


### FID Plots for SN-GAN training on CIFAR-10

#### FID v/s number of steps
![FID_Plot](plots/SNGAN_FID.png)




