##  Steps to train Image classification on Cifar-10

###  Training the network
We support training of CIFAR-10 using 3 architectures: VGG11, ResNet34, DenseNet121. To train the network run the command:

>python main.py --optim adabelief --lr 1e-3 --eps 1e-8 --beta1 0.9 --beta2 0.999 --momentum 0.9

The parameters for different optimizers and runtime for the experiments can be looked up from [here](../../README.md).

### Visualizing results
During training data points for train and test accuracies are stored in the curve folder. To visualize train, test accuracies v/s epochs refer [here](visualization.ipynb)

### CIFAR-10 Test accuracies
We report results for 3 independent runs 

#### VGG11
![CIFAR-10 VGG11](plots/Figure_4atest.png)
#### ResNet34
![CIFAR-10 VGG11](plots/Figure_4btest.png)
#### DenseNet121
![CIFAR-10 VGG11](plots/Figure_4ctest.png)
